

from django_rbac.utils import get_ou_model

from authentic2.decorators import GlobalCache


def label_from_user(user):
    labels = []
    if user.first_name or user.last_name:
        labels.append(user.first_name)
        if user.first_name and user.last_name:
            labels.append(u' ')
        labels.append(user.last_name)
    if user.email and user.email not in labels:
        if labels:
            labels.append(u' - ')
        labels.append(user.email)
    if user.username and user.username not in labels:
        if labels:
            labels.append(u' - ')
        labels.append(user.username)
    return u''.join(labels)


@GlobalCache(timeout=10)
def get_ou_count():
    return get_ou_model().objects.count()
